package dev.shadowsoffire.apotheosis.adventure.affix.augmenting;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.blaze3d.systems.RenderSystem;
import dev.shadowsoffire.apotheosis.adventure.affix.augmenting.AugmentingScreen;
import dev.shadowsoffire.apotheosis.adventure.client.SimpleTexButton;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.ChatFormatting;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.Button;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;

public class FatTexButton extends SimpleTexButton {
  protected final Component costMsg;
  
  public FatTexButton(int x, int y, int width, int height, int u, int v, Button.OnPress press, Component message, Component costMsg) {
    super(x, y, width, height, u, v, AugmentingScreen.TEXTURE, 256, 307, press, message);
    this.costMsg = costMsg;
  }
  
  public void m_87963_(GuiGraphics gfx, int pMouseX, int pMouseY, float pPartialTick) {
    int yTex = this.yTexStart - 2;
    if (!m_142518_()) {
      yTex += this.f_93619_ + 4;
    } else if (m_274382_()) {
      yTex += (this.f_93619_ + 4) * 2;
    } 
    RenderSystem.enableDepthTest();
    RenderSystem.enableBlend();
    gfx.m_280163_(this.texture, m_252754_() - 2, m_252907_() - 2, (this.xTexStart - 2), yTex, this.f_93618_ + 4, this.f_93619_ + 4, this.textureWidth, this.textureHeight);
    if (m_274382_())
      renderToolTip(gfx, pMouseX, pMouseY); 
  }
  
  public void renderToolTip(GuiGraphics gfx, int pMouseX, int pMouseY) {
    if (m_6035_() != CommonComponents.f_237098_ && m_274382_()) {
      MutableComponent mutableComponent;
      Component primary = m_6035_();
      if (!this.f_93623_)
        mutableComponent = primary.m_6881_().m_130940_(ChatFormatting.GRAY); 
      List<Component> tooltips = new ArrayList<>();
      tooltips.add(mutableComponent);
      if (m_142518_()) {
        tooltips.add(this.costMsg);
      } else if (this.inactiveMessage != CommonComponents.f_237098_) {
        tooltips.add(this.inactiveMessage);
      } 
      gfx.m_280666_((Minecraft.m_91087_()).f_91062_, tooltips, pMouseX, pMouseY);
    } 
  }
  
  public boolean m_6050_(double pMouseX, double pMouseY, double pDelta) {
    if (this == AugmentingScreen.this.rerollBtn && m_142518_() && m_274382_()) {
      int change = (pDelta < 0.0D) ? 1 : -1;
      int page = AugmentingScreen.this.alternativePage;
      page = Math.floorMod(page + change, AugmentingScreen.this.alternativePages.size());
      AugmentingScreen.this.alternativePage = page;
      return true;
    } 
    return super.m_6050_(pMouseX, pMouseY, pDelta);
  }
}
